'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.doesReturnJSX = exports.isTypeJSX = exports.isArrowFunction = undefined;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isArrowFunction = exports.isArrowFunction = function isArrowFunction(_ref) {
  var type = _ref.type;
  return type === 'ArrowFunctionExpression';
};

var isTypeJSX = exports.isTypeJSX = function isTypeJSX(_ref2) {
  var type = _ref2.type;
  return type === 'JSXElement';
};

var doesReturnJSX = exports.doesReturnJSX = function doesReturnJSX(_ref3) {
  var body = _ref3.body;

  if (isTypeJSX(body)) {
    return true;
  }

  var block = body.body;

  if (block && block.length) {
    var lastBlock = block.slice(0).pop();

    if (lastBlock.type === 'ReturnStatement') {
      return isTypeJSX(lastBlock.argument);
    }
  }

  return false;
};

exports.default = function (_ref4) {
  var t = _ref4.types;
  return {
    visitor: {
      ExportDefaultDeclaration: function ExportDefaultDeclaration(_ref5, _ref6) {
        var node = _ref5.node;
        var opts = _ref6.file.opts;

        if (isArrowFunction(node.declaration)) {
          if (doesReturnJSX(node.declaration)) {
            var displayName = opts.basename;

            // ./{module name}/index.js
            if (displayName === 'index') {
              displayName = _path2.default.basename(_path2.default.dirname(opts.filename));
            }

            // set display name
            // eslint-disable-next-line no-param-reassign
            node.declaration.id = t.identifier(displayName);
          }
        }
      }
    }
  };
};